---
title: Window.self
slug: Web/API/Window/self
tags:
  - API
  - HTML DOM
  - Property
  - Read-only
  - Reference
  - Window
---
<div>{{APIRef}}</div>

<p>The <code><strong>Window.self</strong></code> read-only property returns the window itself, as a {{domxref("WindowProxy")}}. It can be used with dot notation on a <code>window</code> object (that is, <code>window.self</code>) or standalone (<code>self</code>). The advantage of the standalone notation is that a similar notation exists for non-window contexts, such as in {{domxref("Worker", "Web Workers", "", 1)}}. By using <code>self</code>, you can refer to the global scope in a way that will work not only in a window context (<code>self</code> will resolve to <code>window.self</code>) but also in a worker context (<code>self</code> will then resolve to {{domxref("WorkerGlobalScope.self")}}).</p>

<h2 id="Notes">Example</h2>

<p>Uses of <code>window.self</code> like the following could just as well be replaced by <code>window</code>.</p>

<pre class="brush:js">if (window.parent.frames[0] != window.self) {
    // this window is not the first frame in the list
}
</pre>

<p>Furthermore, when executing in the active document of a browsing context, <code>window</code> is a reference to the current global object and thus all of the following are equivalent:</p>

<pre class="brush:js">var w1 = window;
var w2 = self;
var w3 = window.window;
var w4 = window.self;
// w1, w2, w3, w4 all strictly equal, but only w2 will function in workers
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#dom-self', 'Window.self')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>No difference from the latest snapshot {{SpecName("HTML5.1")}}</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', 'browsers.html#dom-self', 'Window.self')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td>No difference from the {{SpecName("HTML5 W3C")}}</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'browsers.html#dom-self', 'Window.self')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>First snapshot containing the definition of <code>Window.self</code>.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Window.self")}}</p>

<h2 class="noinclude" id="See_also">See also</h2>

<ul>
 <li>Its <code>Worker</code> equivalent, {{domxref("WorkerGlobalScope.self")}}.</li>
</ul>
